/******************************************
 *                DEFINEs                *
 ******************************************/

#define MAX_ELEM 100000
#define DIM_NODE 3
#define NUM_CHILDREN 0
#define CHILDREN 0
#define rSIBLI 1
#define T_STAMP 0
#define FATHER 0
#define LAST_EL 1
#define ITEMS 2
#define COUNT 1
#define true 1
#define false 0

/******************************************
 *                TYPEDEFs                *
 ******************************************/

typedef int * TRANSACTION;

typedef struct itemset_list IL;
struct itemset_list{
 int item_id;
 int count;
 void *ptr1;
 void *ptr2;
};

typedef struct NODE * pNODE;
struct NODE{
 int val;
 pNODE  pt;
};
typedef pNODE * hash;
typedef struct p_elem_arr * P_arr;

/******************************************
 *         FUNCTION DECLARATIONS          *
 ******************************************/

/* Input-Output functions: defined in pat-io.c */

void pat_error(char * s);
void read_param(int, char *[]);
void usage(char *);
void printSet(int length, int *iset,int support);
int  read_int(int *item, char *c);
void init_out();
void init_count();
void init_transaction_read();
void done_transaction_read();
void done_write();
int  getNextTransaction(TRANSACTION *t);

/* Functions used in tree construction: defined in pat-treeutils.c */

void  Tran_sort(TRANSACTION t, int left, int right);
void  IL_sort(IL *ilp, int left, int right);
IL *  make_IL(int *freq);
int   f_hash(int item, int elm_hash);
void  insert_in_hash(hash *fg, pNODE *f, int pos);
void  new_hash(pNODE *p, int num_buckets);
pNODE create_node(TRANSACTION t, pNODE father);
void  split_node(pNODE *nodo, int ind1);
void  split_2node(pNODE *nodo, int ind1, TRANSACTION tran);
void  FP_tree_insert(pNODE *p, TRANSACTION t);
void  insert(pNODE *pl, pNODE newl, int h);
void  visit_tree(IL *ilp, pNODE p, pNODE *newtree, int liv, pNODE pd);

/* Functions used in freq. itemset computation: defined in pat-compute.c */

void DirectCompute(IL *ilp, int l, int s);
void Build(IL *oldilp, IL *newilp, pNODE **newtree, int l);
void Traverse_and_Count(IL *ilp, int l, int timestamp);
void FreqItemCompute(IL *ilp, int nofreq, int s);
